'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Prefetcher = function Prefetcher(_ref) {
    var onClickAction = _ref.onClickAction,
        prefetch = _ref.prefetch,
        children = _ref.children;

    var prefetching = false,
        fetching = false,
        result = undefined;

    var handleMouneEnter = function handleMouneEnter() {
        if (result || fetching || prefetching) {
            return;
        }

        prefetching = true;

        prefetch().then(function (response) {
            prefetching = false;
            result = response;

            fetching && onClickAction(result);
        });
    };

    var handleChildClicked = function handleChildClicked() {
        fetching = true;

        if (result) {
            onClickAction(result);
        } else if (prefetching) {
            return;
        } else {
            prefetch();
        }
    };

    return _react2.default.cloneElement(children, {
        onClick: handleChildClicked,
        onMouseEnter: handleMouneEnter
    });
};

exports.default = Prefetcher;